import React from "react";
import { BlurView } from "expo-blur";
import { ActivityIndicator } from "react-native";
import { connect } from "react-redux";
import tw from "tailwind-rn";

function Blur({ theme }) {
  return (
    <BlurView
      intensity={280}
      tint="dark"
      style={[
        { width: "100%", height: "100%" },
        tw("flex-1 flex justify-center items-center"),
      ]}
    >
      <ActivityIndicator size="large" color="#12CF7F" />
    </BlurView>
  );
}

const mapStateToProps = (state) => ({
  theme: state.publicApi.theme,
});

export default connect(mapStateToProps)(Blur);
