import React from "react";
import { View, Text } from "react-native";
import { connect } from "react-redux";
import tw from "tailwind-rn";

const Divider = ({ type, theme }) => {
  return (
    <View
      style={[
        tw(`bg-gray-100 ${theme === "light" ? "" : "bg-opacity-40"} my-4`),
        {
          height: type === "horizontal" ? "100%" : 1,
          width: type === "horizontal" ? 1 : "100%",
        },
      ]}
    ></View>
  );
};

const mapStateToProps = (state) => ({
  theme: state.publicApi.theme,
});

export default connect(mapStateToProps)(Divider);
