import { View, Text, Pressable } from "react-native";
import React from "react";
import { connect } from "react-redux";

//style
import Colors from "../constants/Colors";
import tw from "tailwind-rn";
import fontSize from "../constants/fontSize";

const Empty = ({ text, buttonText, buttonAction, theme }) => {
  return (
    <View style={tw("flex-1 flex justify-center items-center")}>
      <Text
        style={[
          {
            fontFamily: "regular",
            fontSize: fontSize.tiny,
            transform: [{ translateY: -50 }],
            color:
              theme === "light" ? Colors.theme1.gray20 : Colors.theme1.white,
          },
        ]}
      >
        {text + " " + ":("}
      </Text>
      {buttonText ? (
        <Pressable
          style={[
            tw("py-2 px-5 rounded-sm"),
            {
              backgroundColor: theme === "light" ? Colors.theme1.greenCF : null,
              borderWidth: theme === "light" ? 0 : 1,
              borderColor: Colors.theme1.greenCF,
            },
          ]}
          onPress={() => buttonAction()}
        >
          <Text
            style={[
              tw("text-white"),
              {
                fontFamily: "regular",
                fontSize: fontSize.tiny,
                color:
                  theme === "light"
                    ? Colors.theme1.white
                    : Colors.theme1.greenCF,
              },
            ]}
          >
            {buttonText}
          </Text>
        </Pressable>
      ) : null}
    </View>
  );
};

const mapStateToProps = (state) => ({
  theme: state.publicApi.theme,
});

export default connect(mapStateToProps)(Empty);
