import React from 'react';
import {StyleSheet, Text, Pressable, Dimensions } from 'react-native';

export default function FormButton({text, color, onPress}) {
  const styles = StyleSheet.create({
    button: {
      width : '100%',
      alignItems: 'center',
      justifyContent: 'center',
      paddingVertical: 12,
      paddingHorizontal: 0,
      borderRadius: 6,
      elevation: 3,
      backgroundColor: color,
    },
    text: {
      fontSize: Dimensions.get('window').width / 25,
      color: 'white',
    },
  });
  return (
    <Pressable
      color={color}
      style={styles.button}
      onPress={() => onPress}
    >
      <Text style={styles.text}>{text}</Text>
    </Pressable>
  );
}
