import * as React from 'react';
import { View, Button } from 'react-native';
import { Audio } from 'expo-av';

export default function VoicePlayer({fileIds}) {
  const [sound, setSound] = React.useState();

  async function playSound() {
    const { sound } = await Audio.Sound.createAsync(
       {uri : `https://dnvn.ir/api/v1/file/${fileIds}`}
    );
    setSound(sound);

    await sound.playAsync(); }

  React.useEffect(() => {
    return sound
      ? () => {
          sound.unloadAsync(); }
      : undefined;
  }, [sound]);

  return (
    <View style={styles.container}>
      <Button title="Play Sound" onPress={playSound} />
    </View>
  );
}