import React from "react";
import { View, Text, Dimensions, Image } from "react-native";
import tw from "tailwind-rn";
import leftIcon from "../assets/icons/leftWhite.png";

const width = Dimensions.get("window").width;
const height = Dimensions.get("window").height;

export default function Redirect({ text }) {
  return (
    <View
      style={[
        tw("w-full flex flex-row-reverse items-center p-4 rounded-md mb-5"),
        { backgroundColor: "#196EC0" },
      ]}
    >
      <View style={tw("flex-1 flex ")}>
        <Text
          style={[
            tw("font-medium text-right"),
            { fontSize: width / 30, color: "white" },
          ]}
        >
          {text}
        </Text>
      </View>
      <View style={tw("p-0")}>
        <Image source={leftIcon} style={{ width: 24, height: 24 }} />
      </View>
    </View>
  );
}
