import proxy from "../proxy";

const userAddress = {
  list:
    (data = {}) =>
    async (dispatch) => {
      await proxy.get("userAddress/list", data, { dispatch });
    },
  info:
    (data = {}) =>
    async (dispatch) => {
      await dispatch({ type: "userAddress/info", data });
    },
  update:
    (data = {}, data2 = {}) =>
    async (dispatch) => {
      await proxy.put("userAddress/update", data);
      await proxy.get("userAddress/list", data2, { dispatch });
    },
  add:
    (data = {}, data2 = {}, data3 = {}) =>
    async (dispatch) => {
      await proxy.post("userAddress/add", data);
      setTimeout(() => {
        proxy.get("userAddress/list", data2, { dispatch });
      }, 600);
    },
  del:
    (data = {}, data2 = {}) =>
    async (dispatch) => {
      await proxy.delete("userAddress/delete", data);
      await proxy.get("userAddress/list", data2, { dispatch });
    },
};

export default userAddress;
