const initialState = {
  loading: false,
  error: null,
  list: [],
  info: null,
  hashtags : [],
  hashtag : null,
};
export default function blog(state = initialState, action) {
  let { type, data } = action;
  switch (type) {
    case "public/setHashtag":
      return {
        ...state,
        loading: false,
        hashtag: data,
        error: null,
      };
    case "public/blogList":
      return {
        ...state,
        loading: false,
        list: data,
        hashtags: [...new Set(data.map((object) => object.tag))],
        error: null,
      };
    case "public/blogInfo":
      return { ...state, loading: false, error: null, blog: data };
    case "blog/loading":
      return { ...state, loading: true };
    case "blog/error":
      return { ...state, loading: false, error: data.message };
    default:
      return state;
  }
}
