import proxy from "../proxy";
import AsyncStorage from "@react-native-async-storage/async-storage";
import {asyncAwesomeAlert} from '../../utils/AsyncWrappers';

let initialState = {
  status: null,
  loading: false,
  error: null,
  list: null,
  domains: [],
  mothers: [],
  profileStatus: false,
  setDone: false,
  setLogin: false,
  check: "check",
  profileFields : {
    
  },
};

const user = (state = initialState, action) => {
  let { type, data } = action;
  switch (type) {
    // case "user/login":
    // case "user/register":
    // case "user/switchRole":
    case "public/sendOTP":
      return { ...state, loading: false, error: null };
    case "user/getStatus":
      return { ...state, status: JSON.parse(data.status), error: null };
    case "user/login":
    case "user/otp/login":
      return {
        ...state,
        loading: false,
        status: data.profile,
        error: null,
        setLogin: !state.setLogin,
      };
    case "user/getProfile":
      const myData = JSON.stringify(data);
      try {
        AsyncStorage.setItem("userData", myData);
      } catch (error) {
        ("user/getProfile", error);
      }
      return {
        ...state,
        loading: false,
        status: data,
        error: null,
        setDone: false,
      };
    case "user/logout":
      return { ...state, loading: false, status: null, error: null };
    case "user/getUserRole":
      return { ...state, loading: false, userRoles: data, error: null };
    case "user/setProfile":
      return { ...state, loading: false, error: null, setDone: true };
    case "user/setProfileFields":
      return { ...state, loading: false, error: null, profileFields: data };
    case "user/loading":
      return { ...state, loading: true };
    case "user/error":
      asyncAwesomeAlert("خطا", data.message, {
        showCancelButton: false,
        confirmText: "باشه"
      });
      return { ...state, error : true };
    default:
      return state;
  }
};

export default user;
