import { asyncAwesomeAlert } from "../../utils/AsyncWrappers";

const initialState = {
  loading: false,
  error: null,
  list: null,
  info: null,
  sum: null,
  checkEmpty: false,
  isVerified: null,
  fullList: [],
};
export default function userFactor(state = initialState, action) {
  // const navigation = useNavigation();

  let { type, data } = action;
  switch (type) {
    //dnvn
    case "userFactor/list":
      const checkEmpty = data.filter(
        (item) => item.condition === 2 && item.product.productType === (1 || 3)
      );
      return {
        ...state,
        loading: false,
        list: data,
        checkEmpty: checkEmpty.length > 0 ? false : true,
        error: null,
      };
    case "userFactor/fullList":
      return {
        ...state,
        loading: false,
        fullList: data,
        error: null,
      };
    case "userFactor/info":
      return { ...state, loading: false, info: data, error: null };
    case "userFactor/add":
      return { ...state, loading: false, error: null, sum: data.payPrice };
    case "userFactor/delete":
      return { ...state, loading: false, error: null };
    case "userFactor/payment":
      return { ...state, loading: false, error: null };
    //vod
    case "userFactor/myList":
      return { ...state, loading: false, list: data, error: null };
    case "userFactor/update":
      return { ...state, loading: false, error: null };
    case "userFactor/deleteUserOffCode":
      return { ...state, loading: false, error: null };
    case "userFactor/paymentVOD":
      return { ...state, loading: false, error: null, isVerified: false };
    case "userFactor/verifyVOD":
      return { ...state, loading: false, error: null, isVerified: true };
    case "userFactor/loading":
      return { ...state, loading: true };
    case "userFactor/error":
      asyncAwesomeAlert("خطا", data.message, {
        showCancelButton: false,
        confirmText: "باشه"
      });
      return { ...state, loading: false, error: data.message };
    default:
      return state;
  }
}
