import { asyncApiAwesomeAlert } from "../../utils/AsyncWrappers";

const initialState = {
  loading: false,
  error: null,
};

export default function vote(state = initialState, action) {
  let { type, data } = action;
  switch (type) {
    case "userVote/add":
      asyncAwesomeAlert("نتیجه", "رای شما با موفقیت ثبت شد.", {
        showCancelButton: false,
      });
      return { ...state, loading: false, error: null };
    case "userVote/loading":
      return { ...state, loading: true };
    case "userVote/error":
      asyncAwesomeAlert("خطا", data.message, {
        showCancelButton: false,
        confirmText: "باشه"
      });
      return { ...state, loading: false, error: data.message };
    default:
      return state;
  }
}
