import React from "react";
import { Text, Dimensions, Pressable, Image, Platform } from "react-native";
import { connect } from "react-redux";
import { useNavigation } from "@react-navigation/native";

//style
import tw from "tailwind-rn";
import fontSize from "../../../constants/fontSize";
import Colors from "../../../constants/Colors";

const { width } = Dimensions.get("window");
const ios = Platform.OS === "ios";

export const New = ({ blog, theme }) => {
  const navigation = useNavigation();
  return (
    <Pressable
      style={[
        tw(`flex  ml-4 ${ios ? "items-end" : ""}`),
        {
          width: width / 2,
        },
      ]}
      onPress={() => navigation.push("Blog", { id: blog.id })}
    >
      <Image
        source={{ uri: `https://dnvn.ir/api/v1/file/${blog?.fileIds}` }}
        resizeMode="contain"
        style={[
          tw("rounded-sm"),
          { width: "100%", height: ((width / 2) * 3) / 4.2 },
        ]}
      />
      <Text
        style={{
          fontSize: fontSize.tiny,
          fontFamily: "bold",
          color: theme === "light" ? Colors.theme1.gray20 : Colors.theme1.grayF9,
          marginTop: 5,
          textAlign: ios ? "right" : "auto",
        }}
      >
        {blog?.title}
      </Text>
      <Text
        style={{
          fontSize: fontSize.xs,
          fontFamily: "regular",
          color:
            theme === "light" ? Colors.theme1.gray2077 : Colors.theme1.grayF9,
          textAlign: ios ? "right" : "auto",
          marginTop: 5,
        }}
      >
        هر نفسی که فرو می‌ بریم، مرگی را که مدام به ما دست‌ اندازی می‌کند پس
      </Text>
    </Pressable>
  );
};

const mapStateToProps = (state) => ({
  theme: state.publicApi.theme,
});

export default connect(mapStateToProps)(New);
