import { View, Text, TouchableOpacity } from "react-native";
import { Entypo } from "@expo/vector-icons";
import { connect } from "react-redux";
//style
import tw from "tailwind-rn";
import fontSize from "../../../constants/fontSize";
import Colors from "../../../constants/Colors";

function Instance({ question, selectFaq, mobile, theme }) {
  return (
    <TouchableOpacity
      onPress={() => selectFaq(question.id)}
      style={[
        tw(`w-full flex  my-1.5 rounded-sm px-4 ${mobile ? "py-2" : "py-3"}`),
        {
          backgroundColor: !question.active
            ? theme === "light"
              ? "#F9F9F9"
              : null
            : Colors.theme1.greenCF + "0a",
          borderColor: !question.active
            ? "#DBDBDB" + (theme === "light" ? "" : "88")
            : Colors.theme1.greenCF,
          borderWidth: 1.5,
        },
      ]}
    >
      <View style={tw("flex flex-row-reverse justify-between items-center")}>
        <Text
          style={[
            {
              width: "90%",
              textAlign: "right",
              color:
                theme === "light"
                  ? Colors.theme1.green79
                  : Colors.theme1.grayF9,
              fontSize: mobile ? fontSize.tiny : fontSize.lg,
              fontFamily: "bold",
            },
          ]}
        >
          {question.title}
        </Text>
        {question.active ? (
          <Entypo
            name="minus"
            size={18}
            color={
              theme === "light" ? Colors.theme1.green79 : Colors.theme1.grayF9
            }
          />
        ) : (
          <Entypo
            name="plus"
            size={18}
            color={
              theme === "light" ? Colors.theme1.green79 : Colors.theme1.grayF9
            }
          />
        )}
      </View>
      {question.active ? (
        <View style={tw("w-full flex flex-row-reverse pt-2")}>
          <Text
            style={[
              {
                color:
                  theme === "light"
                    ? Colors.theme1.green79
                    : Colors.theme1.grayF9,
                fontSize: mobile ? fontSize.tiny : fontSize.lg,
                fontFamily: "light",
              },
              tw("text-right flex-1"),
            ]}
          >
            {question.description}
          </Text>
        </View>
      ) : null}
    </TouchableOpacity>
  );
}

const mapStateToProps = (state) => ({
  mobile: state.publicApi.mobile,
  theme: state.publicApi.theme,
});

export default connect(mapStateToProps)(Instance);
