import {
  View,
  Text,
  ScrollView,
  Appearance,
  Platform,
  StyleSheet,
  SafeAreaView,
  StatusBar,
  Dimensions,
} from "react-native";
import { connect } from "react-redux";
import React from "react";
import HTMLView from "react-native-htmlview";

//components
import Navbar from "../../../components/Navbar";

//style
import fontSize from "../../../constants/fontSize";
import tw from "tailwind-rn";
import Colors from "../../../constants/Colors";

//variables
const ios = Platform.OS === "ios";
const { width, height } = Dimensions.get("window");

const Info = ({
  route,
  questionList = [
    {
      question:
        "خالد حسینی تو رمان باد بادک باز مینویسه : ﻣﺮﺩ ﺁﻫﺴﺘﻪ ﺩﺭ ﮔﻮﺵ ﻓﺮﺯﻧﺪ ﺗﺎﺯﻩ ﺑﻪ ﺑﻠﻮﻍ ﺭﺳﯿﺪﻩ ﺍﺵ ﺑﺮﺍﯼ ﭘﻨﺪ ﭼﻨﯿﻦ ﻧﺠﻮﺍ ﮐﺮﺩ؟",
      answer:
        "خالد حسینی تو رمان باد بادک باز مینویسه : ﻣﺮﺩ ﺁﻫﺴﺘﻪ ﺩﺭ ﮔﻮﺵ ﻓﺮﺯﻧﺪ ﺗﺎﺯﻩ ﺑﻪ ﺑﻠﻮﻍ ﺭﺳﯿﺪﻩ ﺍﺵ ﺑﺮﺍﯼ ﭘﻨﺪ ﭼﻨﯿﻦ ﻧﺠﻮﺍ ﮐﺮﺩ : ” ﭘﺴﺮﻡ ﺩﺭ ﺯﻧﺪﮔﯽ ﻫﺮﮔﺰ ﺩﺯﺩﯼ ﻧﮑﻦ ” ﭘﺴﺮ ﻣﺘﻌﺠﺐ ﻭ ﻣﺒﻬﻮﺕ ﺑﻪ ﭘﺪﺭ ﻧﮕﺎﻩ ﮐﺮﺩ ﺑﺪﯾﻦ ﻣﻌﻨﺎ ﮐﻪ ﺍﻭ ﻫﺮﮔﺰ ﺩﺳﺖ ﮐﺞ ﻧﺪﺍﺷﺘﻪ ﭘﺪﺭ ﺑﻪ ﻧﮕﺎﻩ ﻣﺘﻌﺠﺐ ﻓﺮﺯﻧﺪ ﻟﺒﺨﻨﺪﯼ ﺯﺩ ﻭ ﺍﺩﺍﻣﻪ ",
      like: 10,
    },
    {
      question:
        "خالد حسینی تو رمان باد بادک باز مینویسه : ﻣﺮﺩ ﺁﻫﺴﺘﻪ ﺩﺭ ﮔﻮﺵ ﻓﺮﺯﻧﺪ ﺗﺎﺯﻩ ﺑﻪ ﺑﻠﻮﻍ ﺭﺳﯿﺪﻩ ﺍﺵ ﺑﺮﺍﯼ ﭘﻨﺪ ﭼﻨﯿﻦ ﻧﺠﻮﺍ ﮐﺮﺩ؟",
      answer: null,
      like: 0,
    },
    {
      question:
        "خالد حسینی تو رمان باد بادک باز مینویسه : ﻣﺮﺩ ﺁﻫﺴﺘﻪ ﺩﺭ ﮔﻮﺵ ﻓﺮﺯﻧﺪ ﺗﺎﺯﻩ ﺑﻪ ﺑﻠﻮﻍ ﺭﺳﯿﺪﻩ ﺍﺵ ﺑﺮﺍﯼ ﭘﻨﺪ ﭼﻨﯿﻦ ﻧﺠﻮﺍ ﮐﺮﺩ؟",
      answer:
        "خالد حسینی تو رمان باد بادک باز مینویسه : ﻣﺮﺩ ﺁﻫﺴﺘﻪ ﺩﺭ ﮔﻮﺵ ﻓﺮﺯﻧﺪ ﺗﺎﺯﻩ ﺑﻪ ﺑﻠﻮﻍ ﺭﺳﯿﺪﻩ ﺍﺵ ﺑﺮﺍﯼ ﭘﻨﺪ ﭼﻨﯿﻦ ﻧﺠﻮﺍ ﮐﺮﺩ : ” ﭘﺴﺮﻡ ﺩﺭ ﺯﻧﺪﮔﯽ ﻫﺮﮔﺰ ﺩﺯﺩﯼ ﻧﮑﻦ ” ﭘﺴﺮ ﻣﺘﻌﺠﺐ ﻭ ﻣﺒﻬﻮﺕ ﺑﻪ ﭘﺪﺭ ﻧﮕﺎﻩ ﮐﺮﺩ ﺑﺪﯾﻦ ﻣﻌﻨﺎ ﮐﻪ ﺍﻭ ﻫﺮﮔﺰ ﺩﺳﺖ ﮐﺞ ﻧﺪﺍﺷﺘﻪ ﭘﺪﺭ ﺑﻪ ﻧﮕﺎﻩ ﻣﺘﻌﺠﺐ ﻓﺮﺯﻧﺪ ﻟﺒﺨﻨﺪﯼ ﺯﺩ ﻭ ﺍﺩﺍﻣﻪ ",
      like: 10,
    },
  ],
  reviewList = [
    {
      title: "آیا ارزش خرید دارد یا خیر؟",
      text: "هر نفسی که فرو می‌ بریم، مرگی را که مدام به ما دست‌ اندازی می‌کند پس می‌زند... در نهایت این مرگ است که باید پیروز شود، زیرا از هنگام تولد بخشی از سرنوشت ما شده و فقط مدت کوتاهی پیش از بلعیدن طعمه اش، با آن بازی می کند. با این همه، ما تا آنجا که ممکن است، با علاقه فراوان و دلواپسی زیاد به زندگی ادامه می دهیم، همان‌ طور که تا آنجا که ممکن است طولانی‌ تر در یک حباب صابون می‌ دمیم تا بزرگتر شود، گر چه با قطعیتی تمام می‌ دانیم که خواهد ترکید و ",
      images: [0, 1],
    },
  ],
  specificationsList,
  mobile,
  theme,
}) => {
  const { type, data } = route.params;
  const components = React.useMemo(() => {
    return {
      productQuestion: (
        <ProductQuestion list={data} mobile={mobile} theme={theme} />
      ),
      productReview: (
        <ProductReviews list={data} mobile={mobile} theme={theme} />
      ),
      productSpecifications: (
        <ProductSpecifications list={data} mobile={mobile} theme={theme} />
      ),
      productDescription: (
        <ProductDescription mobile={mobile} theme={theme} text={data} />
      ),
    };
  }, [type]);

  const styles = React.useMemo(() => {
    return StyleSheet.create({
      contentContainerStyle: {
        paddingBottom: height / 4,
      },
      container: {
        flexDirection: "column",
        paddingVertical: 5,
        paddingHorizontal: 16,
      },
    });
  }, [type]);

  return (
    <SafeAreaView
      style={{
        paddingTop: Platform.OS === "android" ? StatusBar.currentHeight : 0,
        position: "relative",
      }}
    >
      <Navbar
        headerOptions={{
          logo: false,
          menu: false,
          hamburgerMenu: false,
          title: type.name,
          bookmark: false,
          qr: false,
          back: true,
        }}
      />
      <ScrollView
        contentContainerStyle={styles.contentContainerStyle}
        style={styles.container}
      >
        {components[type.value]}
      </ScrollView>
    </SafeAreaView>
  );
};

const ProductDescription = ({ text, mobile, theme }) => {
  const renderNode = React.useCallback(
    (node, index, siblings, parent, defaultRenderer) => {
      if (node.name == "img") {
        const a = node.attribs;
        return (
          <Image
            style={{ width: 300, height: 300 }}
            source={{ uri: node.attribs.src }}
          />
        );
      }
    },
    [text]
  );
  return (
    <View style={{ flex: 1, paddingTop : 40 }}>
      <HTMLView
        value={text}
        renderNode={renderNode}
        stylesheet={{
          p: {
            color:
              theme === "light" ? Colors.theme1.gray20 : Colors.theme1.grayF9,
            textAlign: "right",
            fontFamily: "light",
            lineHeight: 27,
            marginVertical: -35,
            padding: 0,
          },
          strong: {
            color:
              theme === "light" ? Colors.theme1.gray20 : Colors.theme1.grayF9,
            textAlign: "right",
            fontFamily: "light",
            lineHeight: 27,
          },
          ul: {
            textAlign: "right",
            marginVertical: -35,
          },
          li: {
            color:
              theme === "light" ? Colors.theme1.gray20 : Colors.theme1.grayF9,
            textAlign: "right",
            fontFamily: "light",
            lineHeight: 27,
            marginVertical: -30,
          },
        }}
      />
    </View>
  );
};

const ProductQuestion = ({ list, mobile, theme }) => {
  return (
    <View style={{ flex: 1 }}>
      <View
        onPress={() => refRBSheet.current.open()}
        style={[
          tw(
            `flex flex-row-reverse justify-between items-center mt-3 rounded-md px-2 ${
              mobile ? "py-3" : "py-4"
            } mb-4`
          ),
          {
            backgroundColor: Colors.theme1.greenFF1,
          },
        ]}
      >
        <Text
          style={[
            {
              fontSize: mobile ? fontSize.sm : fontSize.xl3,
              color: Colors.theme1.green79,
              fontFamily: "demi",
            },
          ]}
        >
          پرسش و پاسخ
        </Text>
      </View>
      <ScrollView style={tw("flex-1")}>
        {/* {list?.map((question, index) => (
          <Question question={question} key={index} mobile={mobile} />
        ))} */}
      </ScrollView>
    </View>
  );
};

const ProductReviews = ({ list, mobile, theme }) => {
  const Property = React.useCallback(
    ({ question }) => {
      return (
        <View style={[tw("flex  mb-3")]}>
          <View
            onPress={() => refRBSheet.current.open()}
            style={[
              tw(
                `flex flex-row-reverse justify-between items-center mt-3 rounded-md px-2 ${
                  mobile ? "py-3" : "py-4"
                } mb-4`
              ),
              {
                backgroundColor: Colors.theme1.greenFF1 + "66",
              },
            ]}
          >
            <Text
              style={[
                {
                  fontSize: mobile ? fontSize.tiny : fontSize.lg,
                  color:
                    theme === "light"
                      ? Colors.theme1.green79
                      : Colors.theme1.white,
                  fontFamily: "bold",
                },
              ]}
            >
              {question.title}
            </Text>
          </View>
          <Text
            style={{
              fontSize: mobile ? fontSize.tiny : fontSize.base,
              fontFamily: "light",
              color: theme === "light" ? "#275077" : Colors.theme1.white,
              lineHeight: 25,
              textAlign: ios ? "right" : "auto",
            }}
          >
            {question.text}
          </Text>
          <View style={[tw("flex flex-row  justify-between mt-4")]}>
            {question.images.map((image, index) => (
              <View
                key={index}
                style={[
                  tw("rounded-md flex flex-row justify-center items-center"),
                  {
                    width: width / 2 - 24,
                    height: width / 2 - 24,
                    backgroundColor: "#F6F6F6",
                  },
                ]}
              >
                <Text>Pic</Text>
              </View>
            ))}
          </View>
        </View>
      );
    },
    [list, mobile, theme]
  );

  return (
    <View style={{ flex: 1 }}>
      <View
        onPress={() => refRBSheet.current.open()}
        style={[
          tw(
            "flex flex-row-reverse justify-between items-center mt-3 rounded-md px-2 py-3 mb-2"
          ),
          {
            backgroundColor: Colors.theme1.greenFF1,
          },
        ]}
      >
        <Text
          style={[
            {
              fontSize: fontSize.sm,
              color: Colors.theme1.green79,
              fontFamily: "demi",
            },
          ]}
        >
          نقد بررسی و توضیحات تکمیلی محصول
        </Text>
      </View>
      <ScrollView style={tw("flex-1")}>
        {list?.map((question, index) => (
          <Property question={question} key={index} />
        ))}
      </ScrollView>
    </View>
  );
};

const ProductSpecifications = ({ list, mobile, theme }) => {
  const Property = ({ prop }) => {
    return (
      <View style={[tw("flex flex-row-reverse mb-3")]}>
        <View
          style={[
            tw("rounded-md rounded-md"),
            { backgroundColor: "#f8f8f8", width: width / 3.5 },
          ]}
        >
          <Text
            style={[
              tw(`pr-2 ${mobile ? "py-3" : "py-4"}`),
              {
                fontFamily: "regular",
                fontSize: mobile ? fontSize.sm : fontSize.lg,
                color: "#07AFAF",
                textAlign: ios ? "right" : "auto",
              },
            ]}
          >
            {prop?.description || "description"}
          </Text>
        </View>
        <View
          style={[
            tw(`flex-1 mr-2 rounded-md px-2 ${mobile ? " py-3" : "py-4"}`),
            { backgroundColor: "#f8f8f8" },
          ]}
        >
          <Text
            style={[
              tw("text-right"),
              {
                fontFamily: "regular",
                fontSize: mobile ? fontSize.sm : fontSize.base,
                color: "#646464",
              },
            ]}
          >
            {prop?.value || "value"}
          </Text>
        </View>
      </View>
    );
  };

  return (
    <View style={{ flex: 1 }}>
      <View
        onPress={() => refRBSheet.current.open()}
        style={[
          tw(
            "flex flex-row-reverse justify-between items-center mt-3 rounded-md px-3 py-3 mb-4"
          ),
          {
            backgroundColor: Colors.theme1.greenFF1,
          },
        ]}
      >
        <Text
          style={[
            {
              fontSize: fontSize.sm,
              color: Colors.theme1.green79,
              fontFamily: "demi",
            },
          ]}
        >
          مشخصات محصول
        </Text>
      </View>
      <ScrollView style={tw("flex-1")}>
        {list?.map((prop, index) => (
          <Property prop={prop} key={index} />
        ))}
      </ScrollView>
    </View>
  );
};

const mapStateToProps = (state) => ({
  mobile: state.publicApi.mobile,
  theme: state.publicApi.theme,
});

export default connect(mapStateToProps)(Info);
