import React, { useRef } from "react";
import { Text, TouchableOpacity, Appearance } from "react-native";
import { connect } from "react-redux";
import { Entypo } from "@expo/vector-icons";

//style
import tw from "tailwind-rn";
import fontSize from "../../../constants/fontSize";
import Colors from "../../../constants/Colors";

function Description({ title, onPress, mobile, theme }) {
  const refRBSheet = useRef();
  return (
    <TouchableOpacity
      onPress={() => onPress()}
      style={[
        tw(
          `flex flex-row-reverse justify-between items-center mt-3 rounded-sm px-5 ${
            mobile ? "py-4" : "py-4"
          }`
        ),
        {
          backgroundColor:
            theme === "light"
              ? Colors.theme1.greenCF + "15"
              : Colors.theme1.blue90 + "33",
          // borderWidth : 1,
        },
      ]}
    >
      <Text
        style={[
          {
            fontSize: mobile ? fontSize.sm : fontSize.lg,
            color:
              theme === "light" ? Colors.theme1.green79 : Colors.theme1.white,
            fontFamily: "demi",
          },
          tw(""),
        ]}
      >
        {title}
      </Text>
      <Entypo
        name="chevron-small-left"
        size={20}
        color={theme === "light" ? Colors.theme1.green79 : Colors.theme1.white}
      />
    </TouchableOpacity>
  );
}

const mapStateToProps = (state) => ({
  mobile: state.publicApi.mobile,
  theme: state.publicApi.theme,
});

export default connect(mapStateToProps)(Description);
