import React, { useEffect } from "react";
import {
  View,
  StyleSheet,
  Dimensions,
  ScrollView,
  KeyboardAvoidingView,
  SafeAreaView,
  StatusBar,
} from "react-native";
import Book from "./components/Book";
import { book } from "../../redux/actions";
import { connect } from "react-redux";
import Navbar from "../../components/Navbar";

function Product({ route, book, getBook, grades }) {
  useEffect(() => {
    getBook({ id: route.params.id, vod: true });
  }, []);

  console.log(book);

  return (
    <SafeAreaView
      style={{
        paddingTop: Platform.OS === "android" ? StatusBar.currentHeight : 0,
        position: "relative",
      }}
    >
      <Navbar
        headerOptions={{
          logo: false,
          menu: false,
          hamburgerMenu: false,
          title: "",
          bookmark: true,
          qr: false,
          back: true,
          bookmarkItem: { productId: book?.id },
        }}
      />
      <ScrollView
        contentContainerStyle={styles.contentContainerStyle}
        style={styles.container}
        scrollEnabled={book ? true : false}
      >
        <Book book={book} grades={grades} />
      </ScrollView>
    </SafeAreaView>
  );
}

const styles = StyleSheet.create({
  contentContainerStyle: {
    paddingBottom: 100,
  },
  container: {
    flexDirection: "column",
    paddingVertical: 5,
    paddingHorizontal: 16,
  },
});

const mapStateToProps = (state) => ({
  book: state.book.info,
  grades: state.publicApi.grades,
});

const mapDispatchToProps = {
  getBook: book.info,
};

export default connect(mapStateToProps, mapDispatchToProps)(Product);
