import { View, Text } from "react-native";
import React from "react";
import { connect } from "react-redux";
import { book } from "../../../redux/actions";

//style
import tw from "tailwind-rn";

//components
import Search from "../../../components/Search";
import Select from "../../../components/Select";

const Header = ({ setFilterOptions, filterOptions, levels, productTypes }) => {
  return (
    <View style={tw("flex  px-4 h-32")}>
      <Search
        onChange={(val) => setFilterOptions({ ...filterOptions, search: val })}
        placeholder={"نام کتاب یا دوره را جستجو کنید"}
        value={filterOptions.search}
      />
      <View style={[tw("flex flex-1 flex-row justify-between items-center")]}>
        {/* <Select
          defaultValue={productTypes[0]}
          onChange={(name, value) =>
            value !== "نوع محصول"
              ? setFilterOptions({ ...filterOptions, [name]: value })
              : setFilterOptions({ ...filterOptions, [name]: null })
          }
          options={productTypes}
          width={"48%"}
          name="productType"
          disabled={true}
        /> */}
        <Select
          defaultValue={Object.values(levels)[0]}
          onChange={(name, value) =>
            value !== "پایه تحصیلی"
              ? setFilterOptions({ ...filterOptions, [name]: value })
              : setFilterOptions({ ...filterOptions, [name]: null })
          }
          options={Object.values(levels)}
          width={"100%"}
          name="grade"
        />
      </View>
    </View>
  );
};

const mapStateToProps = (state) => ({
  levels: state.publicApi.grades,
  productTypes: state.book.productTypes,
  filterOptions: state.book.filterOptions,
});

const mapDispatchToProps = {
  setFilterOptions: book.setFilterOptions,
};

export default connect(mapStateToProps, mapDispatchToProps)(Header);
