import { View, Text, Platform, Pressable } from "react-native";
import React from "react";
import { connect } from "react-redux";
import Svg, { G, Path } from "react-native-svg";
import { asyncAwesomeAlert } from "../../../utils/AsyncWrappers";

//style
import tw from "tailwind-rn";
import fontSize from "../../../constants/fontSize";
import Colors from "../../../constants/Colors";

const ios = Platform.OS === "ios";

const Trophy = ({ theme }) => {
  return (
    <View
      style={[
        tw(`w-full flex py-3 px-3 justify-between flex-row-reverse mt-4`),
        {
          backgroundColor: theme === "light" ? Colors.theme1.yellow2 : null,
          borderWidth: theme === "light" ? 0 : 1,
          borderColor: Colors.theme1.yellow2 + (theme === "light" ? "" : "77"),
        },
      ]}
    >
      <View style={[tw(`flex flex-row-reverse`)]}>
        <Svg xmlns="http://www.w3.org/2000/svg" width={23.862} height={23.862}>
          <G fill="none" stroke="#d6d020" data-name="vuesax/linear/cup">
            <Path
              d="M12.08 16.405v2.088"
              strokeLinecap="round"
              strokeLinejoin="round"
              strokeWidth="1.5"
            />
            <Path
              data-name="Vector"
              strokeWidth="1.5"
              d="M7.109 21.874h9.942v-.995a1.994 1.994 0 0 0-1.988-1.988H9.097a1.994 1.994 0 0 0-1.988 1.988v.994Z"
            />
            <Path
              data-name="Vector"
              d="M6.115 21.873h11.931M11.931 15.907a6.955 6.955 0 0 1-6.96-6.959V5.965a3.976 3.976 0 0 1 3.977-3.977h5.965a3.976 3.976 0 0 1 3.977 3.977v2.983a6.955 6.955 0 0 1-6.959 6.959Z"
              strokeLinecap="round"
              strokeLinejoin="round"
              strokeWidth="1.5"
            />
            <Path
              data-name="Vector"
              d="M5.438 11.583a4.831 4.831 0 0 1-1.919-1.193 5.3 5.3 0 0 1-1.491-3.579 2.461 2.461 0 0 1 2.486-2.486h.646a3.734 3.734 0 0 0-.3 1.491v2.983a7.007 7.007 0 0 0 .578 2.784ZM18.423 11.583a4.831 4.831 0 0 0 1.919-1.193 5.3 5.3 0 0 0 1.491-3.579 2.461 2.461 0 0 0-2.485-2.486h-.647a3.734 3.734 0 0 1 .3 1.491v2.983a7.007 7.007 0 0 1-.578 2.784Z"
              strokeLinecap="round"
              strokeLinejoin="round"
              strokeWidth="1.5"
            />
          </G>
        </Svg>
        <Text
          style={{
            fontFamily: "regular",
            fontSize: fontSize.tiny,
            marginRight: 10,
            color:
              theme === "light" ? Colors.theme1.green79 : Colors.theme1.yellow2,
          }}
        >
          {"امتیاز شما" + " " + 0}
        </Text>
      </View>
      <Pressable
        onPress={() =>
          asyncAwesomeAlert("نتیجه", "این قابلیت در حال توسعه است.", {
            confirmText: "باشه",
            showCancelButton: false,
          })
        }
      >
        <Text
          style={{
            fontFamily: "light",
            fontSize: fontSize.sm,
            color:
              theme === "light" ? Colors.theme1.green79 : Colors.theme1.yellow2,
          }}
        >
          مشاهده جوایز
        </Text>
      </Pressable>
    </View>
  );
};

const mapStateToProps = (state) => ({
  theme: state.publicApi.theme,
});

export default connect(mapStateToProps)(Trophy);
