import React, { useState } from "react";
import {
  StyleSheet,
  ScrollView,
  SafeAreaView,
  Dimensions,
  StatusBar,
} from "react-native";
import Scan from "./layouts/Scan";

const width = Dimensions.get("window").width;
function QR({ route }) {
  return (
    <SafeAreaView
      style={{
        paddingTop: Platform.OS === "android" ? StatusBar.currentHeight : 0,
      }}
    >
      <ScrollView
        contentContainerStyle={styles.contentContainerStyle}
        style={styles.container}
      >
        <Scan page={route?.params?.page} />
      </ScrollView>
    </SafeAreaView>
  );
}

export default QR;

const styles = StyleSheet.create({
  contentContainerStyle: {
    paddingBottom: 0,
  },
  container: {
    width: Dimensions.get("window").width,
    backgroundColor: "white",
    flexDirection: "column",
    paddingVertical: 0,
    paddingHorizontal: 0,
  },
});
