import React from "react";
import { View, Text, Image, Pressable, Dimensions } from "react-native";

//assets
import linkIcon from "../../../assets/icons/link.png";

//styles
import tw from "tailwind-rn";
import fontSize from "../../../constants/fontSize";
import Colors from "../../../constants/Colors";

const { width } = Dimensions.get("window");

export default function Links({ links }) {
  return (
    <View
      style={tw(
        "w-full flex-row-reverse justify-between items-center rounded-md bg-yellow-100 py-3 px-2 mt-5"
      )}
    >
      <View style={tw("flex  items-end")}>
        <Text
          style={{
            fontSize: fontSize.tiny,
            fontFamily: "bold",
            color:
              theme === "light" ? Colors.theme1.gray2077 : Colors.theme1.white,
          }}
        >
          لینک ها
        </Text>
        {links.map((link, i) => (
          <Pressable style={tw("mt-1")} key={i}>
            <Text style={{ fontSize: width / 34, fontFamily: "light" }}>
              {link}
            </Text>
          </Pressable>
        ))}
      </View>
      <Image source={linkIcon} style={{ width: 40, height: 40 }} />
    </View>
  );
}
