import React from "react";
import { View, Text, Image, Dimensions, TouchableOpacity } from "react-native";
import * as OpenAnything from "react-native-openanything";

//style
import fontSize from "../../../constants/fontSize";
import Colors from "../../../constants/Colors";
import tw from "tailwind-rn";

//assets
import pdfIcon from "../../../assets/icons/pdf.png";

const { width } = Dimensions.get("window");

export default function PDF({ data }) {
  return (
    <TouchableOpacity
      style={tw(
        "w-full flex-row-reverse justify-between items-center rounded-md bg-red-100 py-3 px-2 mt-5"
      )}
      onPress={() =>
        OpenAnything.Pdf(`https://dnvn.ir/api/v1/file/${data.fileIds}`)
      }
    >
      <Text
        style={[
          tw("text-right text-red-900"),
          {
            fontSize: fontSize.tiny,
            fontFamily: "bold",
            color:
              theme === "light" ? Colors.theme1.gray2077 : Colors.theme1.white,
          },
          ,
        ]}
      >
        {data.name}
      </Text>
      <Image source={pdfIcon} style={{ width: 40, height: 40 }} />
    </TouchableOpacity>
  );
}
