import React from "react";
import { View, Text, Image, Dimensions } from "react-native";

//style
import tw from "tailwind-rn";
import fontSize from "../../../constants/fontSize";
import Colors from "../../../constants/Colors";

//assets
import pptIcon from "../../../assets/icons/ppt.png";

const { width } = Dimensions.get("window");

export default function PPT({ name, file }) {
  return (
    <View
      style={tw(
        "w-full flex-row-reverse justify-between items-center rounded-md bg-green-100 py-3 px-2 mt-5"
      )}
    >
      <Text
        style={[
          tw("text-right text-green-900"),
          {
            fontSize: fontSize.tiny,
            fontFamily: "bold",
            color:
              theme === "light" ? Colors.theme1.gray2077 : Colors.theme1.white,
          },
        ]}
      >
        {name}
      </Text>
      <Image source={pptIcon} style={{ width: 40, height: 40 }} />
    </View>
  );
}
