import React from "react";
import { View, Text, Dimensions } from "react-native";
import { Video } from "expo-av";

//style
import fontSize from "../../../constants/fontSize";
import Colors from "../../../constants/Colors";
import tw from "tailwind-rn";

const { width } = Dimensions.get("window");

export default function VideoContent({ data, theme }) {
  const [status, setStatus] = React.useState({});
  const video = React.useRef(null);
  return (
    <View style={tw("w-full  mt-5")}>
      <Text
        style={[
          tw("w-full text-right text-green-900 mb-4"),
          {
            fontSize: fontSize.tiny,
            fontFamily: "bold",
            color:
              theme === "light" ? Colors.theme1.gray2077 : Colors.theme1.white,
          },
        ]}
      >
        {"موضوع:" + " " + data.name}
      </Text>
      <View style={tw("flex ")}>
        <Video
          ref={video}
          style={{ width: "100%", height: (width * 9) / 16 - 16 }}
          source={{
            uri: `https://dnvn.ir/api/v1/file/${data.fileIds}`,
          }}
          useNativeControls
          resizeMode="cover"
          // onFullscreenUpdate={setOrientation}
          isLooping
          onPlaybackStatusUpdate={(status) => setStatus(() => status)}
        />
      </View>
    </View>
  );
}
