import React from "react";
import { View, Text, Dimensions } from "react-native";

//style
import tw from "tailwind-rn";
import fontSize from "../../../constants/fontSize";
import Colors from "../../../constants/Colors";

//components
import MusicPlayer from "../../../components/MusicPlayer";


const { width } = Dimensions.get("window");

export default function Voice({ data }) {
  return (
    <View style={tw("w-full  rounded-md bg-green-200 py-3 px-2 mt-4")}>
      <Text
        style={[
          tw("w-full text-right text-xs text-green-900"),
          {
            fontSize: fontSize.tiny,
            fontFamily: "bold",
            color:
              theme === "light" ? Colors.theme1.gray2077 : Colors.theme1.white,
          },
          ,
        ]}
      >
        {data.name}
      </Text>
      <MusicPlayer fileIds={data.fileIds} />
    </View>
  );
}
