import React from "react";
import { View, Text, FlatList, TouchableOpacity } from "react-native";
import tw from "tailwind-rn";
import fontSize from '../../../constants/fontSize';

import Header from "../../Home/components/Header";

const VerticalGradeFilter = ({ grades }) => {
  const Grade = ({ grade }) => {
    return (
      <TouchableOpacity
        style={[
          tw("px-3 py-1.5 rounded-sm border border-gray-300 mt-2 ml-2"),
          { backgroundColor: "#f9f9f9" },
        ]}
      >
        <Text style={[tw("text-gray-600"), { fontFamily: "light", fontSize: fontSize.sm }]}>
          {grades[grade]}
        </Text>
      </TouchableOpacity>
    );
  };
  return (
    <View style={tw("w-full flex  mt-3")}>
      <Header title={"پایه تحصیلی"} />
      <FlatList
        showsHorizontalScrollIndicator={false}
        style={tw("flex flex-row w-full pb-1.5")}
        horizontal={true}
        inverted={true}
        data={Object.keys(grades)}
        renderItem={({ item }) => <Grade grade={item} />}
        keyExtractor={(item) => item}
      />
    </View>
  );
};


export default VerticalGradeFilter;
